; 

    .486                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

    .data?

    .data

    .code _TEXT

; Copy this
; 
; Conversion from ASCII string to DECimal value DWORD sized, EXtremely fast on P6+ CPUs
; input - pointer to string
; returned number - in eax
; error checking: none, the programmer must be sure, what passed string is the number, not
; "random" bytes, or zero-length string
;
; Special Notes: 
; This version is written for C(++) fastcall calling convention (arg in ecx), and ~4.5% faster
; than not fastcall version.
; Such strange name is used, because ml.exe don't support fastcall convention, and its name
; mangling. This name - is manually mangled name :) So, this compiled proc may be used with
; any Microsoft's C(++) compilers.
; If your version of the ml.exe don't support 16-byte alignment, comment "align 16" lines.
; This proc *support* both signed and unsigned numbers, atodw_ex - not support signed numbers.
; To define signed negative number - set the minus char before number ("-5", for example)
; Positive numbers must be without sign char (i.e. without "+" char, simlpe "5", for example).
;
; This proc be written by me, to replace atodw_ex proc, that have size ~600 bytes
; (from it 400 bytes - decade table).
; This proc have speed, that surpass (small) speed of atodw_ex, exactly - on PIV+.
; I can not test in on machines of P6 class, but I think, that the result the same.

; On my machine, 100,000,000 (100 millions) times of conversion take ~2540 milliseconds,
; and, the same value ^^^ of conversion times in atodw_ex proc take ~2750 milliseconds.
; In short words, this proc have speed more by ~8% than atodw_ex.
; Size of @Axa2l_ex_fastcall@4 - 145 bytes, size of atodw_ex - 673 bytes (code size + decade table size).
; Reports about another CPUs timings greetings.
; P.S. I know about jecxz :), but in my tests, it work better than test...jz.
;
;	Copyright Antariy (Bagayev Alex, Tashkent)
;
    .code _TEXT

option prologue:none
option epilogue:none

; Usage:
; mov ecx,offset StrWithNumber or lea ecx,TheLocalBuffer
; invoke @Axa2l_ex_fastcall@4 or call Axa2l_ex_fastcall
align 16
PUBLIC Axa2l_ex_fastcall
Axa2l_ex_fastcall:
@Axa2l_ex_fastcall@4 proc syscall

    push edi
    
    mov edx,ecx

    xor edi,edi

        xor eax,eax
        movzx ecx,byte ptr [edx]
        cmp cl,'-'
        jnz @preloop
        inc edx
        dec edi

        movzx ecx, byte ptr [edx]
	@preloop:
        
        jecxz @done
        lea eax,[ecx-'0']

        movzx ecx, byte ptr [edx+1]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']
 
        movzx ecx, byte ptr [edx+2]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+3]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+4]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+5]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+6]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+7]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+8]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+9]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

    @done:        


    add eax,edi
    xor eax,edi

    pop edi

    ret

@Axa2l_ex_fastcall@4 endp
option prologue:PrologueDef
option epilogue:EpilogueDef
; 
; End of Copying




; 
; The testing prog
.data
align 16
thestring   db  "1234543210",0
even
aformat     db  "%d",0 ; NOTE!!! Number be converted right, but I specially use signed output in messagebox
                                    ; for showing, what @Axa2l_ex_fastcall@4 support signed numbers,
                                    ; for example change thestring  to "-105", and see results.

.code _TEXT

align 16
start proc uses ebx edi

invoke GetCurrentProcess

invoke SetPriorityClass,eax,REALTIME_PRIORITY_CLASS
invoke Sleep,0

; simple pre-output converted values, to show, what procs work...
mov ecx,offset thestring
invoke @Axa2l_ex_fastcall@4
add esp,-1028
mov ebx,esp
push eax
push offset aformat
push ebx
call wsprintf
push MB_ICONINFORMATION
call @F
db  "Out of @Axa2l_ex_fastcall@4 conversion",0
@@:
push ebx
push 0
call MessageBox

push eax ; because atodw_ex corrupt stack
invoke atodw_ex,offset thestring
pop ecx
push eax
push offset aformat
push ebx
call wsprintf
push MB_ICONINFORMATION
call @F
db  "Out of atodw_ex conversion",0
@@:
push ebx
push 0
call MessageBox


; Simple algo to get timings of @Axa2l_ex_fastcall@4 proc (not clocks cycles - milliseconds)

invoke GetTickCount
neg eax
push eax
mov edi,10000000
align 16
@loop1:
REPEAT 10
mov ecx,offset thestring
invoke @Axa2l_ex_fastcall@4
ENDM
dec edi
jnz @loop1

invoke GetTickCount
add [esp],eax

push offset aformat
push ebx
call wsprintf

push MB_ICONINFORMATION
call @F
db  "@Axa2l_ex_fastcall@4 Timings",0
@@:
push ebx
push 0
call MessageBox


; Simple algo to get timings of atodw_ex proc (not clocks cycles - milliseconds)
; with foreseeng of buf of atodw_ex

invoke GetTickCount
neg eax
push eax
push edx ; because atodw_ex corrupt stack
mov edi,10000000
align 16
@loop2:
REPEAT 10
invoke atodw_ex,offset thestring
ENDM
dec edi
jnz @loop2

invoke GetTickCount
pop edx
add [esp],eax
push offset aformat
push ebx
call wsprintf

push MB_ICONINFORMATION
call @F
db  "atodw_ex Timings",0
@@:
push ebx
push 0
call MessageBox


; quit, and esp restoration (12 - size of args to one wsprintf, wsprintf called 4 times, so...
; I don't restore stack after each call to wsprintf, because in such short code no need in it -
; is possibly restore stack once => reducing code size and execution time :)
add esp,1028+12+12+12+12

@done:
 ret

start endp


end start
