; 

    .486                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

    .data?


    .data

; Copy this
; 
; Conversion from ASCII string to HEXadecimal value DWORD sized
; input - pointer to string
; returned number - in eax
; error checking: none, the programmer must be sure, what passed string is the number, not
; "random" bytes, or zero-length string
;
; Special notes:
; If your version of the ml.exe don't support 16-byte alignment, comment "align 16" lines.
;
; This proc demonstrate the unusually hex-to-dword conversion algo, and, it work fast... very fast
; On my machine, 100,000,000 (100 millions) times of conversion take ~4050 milliseconds,
; and, the same value ^^^ of conversion times in htodw proc take ~7550 milliseconds.
; Size of Axhex2dw - 49 bytes (or 44 - in full hex notation ver), size of htodw - 79 bytes.
; Code of Axhex2dw may be smallest, but this will be harmful to performance.
; And, I can test it only on CPU > P6 family, and on tested CPUs - this variant
; the same fastest. Reports about another CPUs timings greetings.
;
; Maybe I write hex2bin proc based on this algo...
;
; And one more Special Note: THIS PROC IS TEXT-CASE TOLERANT! (i.e. work with "AbCd012" also).
;
;	Copyright (c) Antariy (Bagayev Alex, Tashkent)
;
    .code _TEXT

option prologue:none
option epilogue:none

align 16
Axhex2dw    proc STDCALL lpszStr:DWORD
    push edi
    mov edi,[esp+8]
    xor ecx,ecx
    mov eax,0		; if you have use only full-notated hex numbers, then comment this mnemonic,
    @@:			; i.e, if you use numbers like 00000007, but not 07 or simple 7,
    movzx edx,byte ptr [edi]	; if you use short notation (07 or 7), then eax must be zeroed (mov eax,0 instead
    cmp edx,0			; xor eax,eax used, because it slightly faster, and align loop to 4 bytes).
    jz @done
    test dl,1000000Y
    setne cl
    add edx,ecx
    add edi,1
    shl eax,4h
    lea edx,[edx-30h+ecx*8]
    and edx,0fh
    add eax,edx
    jmp @B

    @done:
    pop edi
    ret 4
Axhex2dw    endp
option prologue:PrologueDef
option epilogue:EpilogueDef
; 
; End of Copying


; 
; The testing prog
    .data

align 16
str1    db  "ABCDEF01",0

.code _TEXT
align 16
start proc uses ebx

invoke GetCurrentProcess
invoke SetPriorityClass,eax,REALTIME_PRIORITY_CLASS
invoke Sleep,0

; simple pre-output converted values, to show, what proc work...
add esp,-1024
invoke Axhex2dw,offset str1
mov ecx,esp
push eax
call @F
db	"%08lX",0
@@:
push ecx
call wsprintf

lea edx,[esp+12]
push MB_ICONINFORMATION
call @F
db	"Converted value",0
@@:
push edx
push 0
call MessageBox


; Simple algo to get timings of Axhex2dw proc (not clocks cycles - milliseconds)
mov ebx,10000000
invoke GetTickCount
neg eax
push eax
@@:
REPEAT 10
invoke Axhex2dw,offset str1
ENDM
dec ebx
jnz @B
invoke GetTickCount
lea edx,[esp+4]
add [esp],eax
call @F
    db  "Axhex2dw Time %d ms",0
@@:
push edx
call wsprintf

lea ecx,[esp+12]    ; because we don't restore stack after wsprintf
push MB_ICONINFORMATION
call @F
db  "Timings",0
@@:
push ecx
push 0
call MessageBox

invoke Sleep,1000


; Simple algo to get timings of htodw proc (not clocks cycles - milliseconds)
mov ebx,10000000
invoke GetTickCount
neg eax
push eax
@@:
REPEAT 10
invoke htodw,offset str1
ENDM
dec ebx
jnz @B
invoke GetTickCount
lea edx,[esp+4]
add [esp],eax
call @F
    db  "htodw Time %d ms",0
@@:
push edx
call wsprintf

lea ecx,[esp+12]    ; because we don't restore stack after wsprintf
push MB_ICONINFORMATION
call @F
db  "Timings",0
@@:
push ecx
push 0
call MessageBox


; quit, and esp restoration (12 - size of args to one wsprintf, wsprintf called 3 times, so...
; I don't restore stack after each call to wsprintf, because in such short code no need in it -
; is possibly restore stack once => reducing code size and execution time :)
add esp,1024+12+12+12

@done:
 ret
 
start endp

end start
